//****************************************************************************
//	aisa35s.pas
//
//	aISA-A35
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/06/29
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa35s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa35w;

const
	szTitle = 'Sample';
	szA35	 = 'aISA-A35';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 String;
	dwDLLVer, dwDrvVer: DWord;
	bResult:	Boolean;				// 
	wLogSlot: Word;						// foCXi[
	b:				Byte;
	ri:				TAISA35RESOURCE;// \[X
	param:				 TAISA35PARA;// TvOp[^
	wSmpData:			 Word;			// TvOf[^
begin
//---------------------------------------------------------------------------
	// aisa35.dll ̎gp錾
	if Aisa35wDllOpen() = False then
	begin
		ErrorMessage(AISA35_SLOT_AUTO);
		Exit;			// aisa35.dll ̃[hɎs܂
	end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aISA-A35 DLL,Driver̃o[Wԍ擾
	if Aisa35wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(AISA35_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Drv Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-A35̎gp錾
	wLogSlot := AISA35_SLOT_AUTO;				// gp̃foCXT܂B

	bResult := Aisa35wCreate(wLogSlot);	// ꍇA̎̃foCXi[܂B

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA35_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-A35 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// \[X擾
	if Aisa35wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
									 'NumPorts: %2d'#10 +
									 'IO Address: %04xH-%04xH',
										 [szA35, ri.dwIOPortLength[1],
											ri.dwIOPortBase[1],
											ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvO
	param.dwSamplingChannel := 1;	// TvOs`l (1`8)
	param.dwResolution := 12;			// \(8 or 12 bits)

	if Aisa35wStartSampling(wLogSlot, @param, wSmpData) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('TvOf[^'#10 +
									 'Data: %03xH',
									 [wSmpData]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// Cӂ̃f[^o
	// o̓f[^ AAh
	b := Byte($AA);

	if Aisa35wOutPort(wLogSlot, b) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('f[^o'#10 +
									 'Out Data: %02xH',
									 [b]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// f[^ǂݍ
	b := Byte($00);

	if Aisa35wInPort(wLogSlot, b) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('f[^'#10 +
									 'In Data: %02xH',
									 [b]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-A35̎gpJ
	if Aisa35wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-A35 Closed');

	// aisa35.dll ̎gpJ
	if Aisa35wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa35.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa35wGetLastError(wLogSlot);

	case dwRes of
		AISA35_ERR_SYSTEM:
			strbuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);

		AISA35_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aISA-A35 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
 
