//****************************************************************************
//	aisa35w.pas
//
//	aISA-A35
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/06/29
//
//****************************************************************************

unit aisa35w;

interface

uses
	Windows;

{ Error Code }

const
	AISA35_SUCCESS								= 0; { Successfully proccessed }
	AISA35_ERR_SYSTEM							= 1; { Call GetLastError() }
	AISA35_ERR_NO_DEVICE					= 2; { No card }
	AISA35_ERR_IN_USE							= 3; { Device is in use }
	AISA35_ERR_INVALID_SLOT				= 4; { Invalid slot number }
	AISA35_ERR_RESOURCE						= 5; { Resource exhaustion }
	AISA35_ERR_INVALID_ARGUMENT		= 6; { Invalid argument }
	AISA35_ERR_NO_CREATE					= 7; { No created device }
	AISA35_ERR_INVALID_CHANNEL		= 8; { Invalid channel }
	AISA35_ERR_INVALID_RESOLUTION =	9; { Invalid resolution }
	AISA35_ERR_TIMEOUT						= 10;{ Conversion timeout }

{ Miscellaneous }

const
	AISA35_MAX_SLOTS	= 16;		{ Maximum number of slots }

	AISA35_SLOT_AUTO = $ffff; { default search }

const
	AISA35_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA35_DLL_NAME = 'aisa35.dll';		{ DLL }

function Aisa35wDllOpen: Boolean;		{ DLL [h }
function Aisa35wDllClose: Boolean;	{ DLL A[h }


{ aISA-A35 DLL,Drṽo[Wԍ擾 }
function Aisa35wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-A35̎gp錾 }
function Aisa35wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-A35̎gpJ }
function Aisa35wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
	AISA35_MAX_MEM			=	 9;
	AISA35_MAX_IO				= 20;
	AISA35_MAX_IRQ			=	 7;
	AISA35_MAX_DMA			=	 7;

type
	TAISA35RESOURCE = record
		dwNumMemWindows:																DWord;	{ س޳(gp) }
		dwMemBase:			array [1 .. AISA35_MAX_MEM] of	DWord;	{ س޳ްڽ(gp) }
		dwMemLength:		array [1 .. AISA35_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwMemAttrib:		array [1 .. AISA35_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwNumIOPorts:																		DWord;	{ I/O߰Đ }
		dwIOPortBase:		array [1 .. AISA35_MAX_IO] of		DWord;	{ I/O߰ްڽ }
		dwIOPortLength: array [1 .. AISA35_MAX_IO] of		DWord;	{ I/O߰Ē }
		dwNumIRQs:																			DWord;	{ IRQ(gp) }
		dwIRQRegisters: array [1 .. AISA35_MAX_IRQ] of	DWord;	{ IRQؽ(gp) }
		dwIRQAttrib:		array [1 .. AISA35_MAX_IRQ] of	DWord;	{ IRQؽ(gp) }
		dwNumDMAs:																			DWord;	{ DMAِ(gp) }
		dwDMALst:				array [1 .. AISA35_MAX_DMA] of	DWord;	{ DMAؽ(gp) }
		dwDMAAttrib:		array [1 .. AISA35_MAX_DMA] of	DWord;	{ DMAّؽ(gp) }
		dwReserved1:		array [1 .. 3] of								DWord;	{ \(gp) }
	end;

PAISA35RESOURCE = ^TAISA35RESOURCE;


{ \[X擾 }
function Aisa35wGetResource(wLogSlot: Word; pres: PAISA35RESOURCE): Boolean;


type
	TAISA35PARA = record
		dwSamplingChannel: DWord;		{ TvOs`li1`8j }
		dwResolution:			 DWord;		{ \i 8 = 8 [bit] / 12 = 12 [bit] j }
	end;

PAISA35PARA = ^TAISA35PARA;

{ A/DTvO̎s }
function Aisa35wStartSampling(wLogSlot: Word; pcpara: PAISA35PARA; var pwSamplingData: Word): Boolean;


{ Cӂ̃|[gf[^ }
function Aisa35wInPort(wLogSlot: Word; var pbInValue: Byte): Boolean;
{ Cӂ̃|[gփf[^o }
function Aisa35wOutPort(wLogSlot: Word; bOutValue: Byte): Boolean;


{ aISA-A35̃G[R[h }
function Aisa35wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa35GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
	TAisa35Create = function(var pwLogSlot: Word): Bool; stdcall;
	TAisa35Close = function(wLogSlot:	Word): Bool; stdcall;
	TAisa35GetResource = function(wLogSlot: Word; pres: PAISA35RESOURCE): Bool; stdcall;
	TAisa35StartSampling = function(wLogSlot: Word; pcpara: PAISA35PARA; var pwSamplingData: Word): Bool; stdcall;
	TAisa35InPort = function(wLogSlot: Word; var pbInValue: Byte): Bool; stdcall;
	TAisa35OutPort = function(wLogSlot: Word; bOutValue: Byte): Bool; stdcall;
	TAisa35GetLastError = function(wLogSlot: Word): DWord; stdcall;

function Aisa35wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa35GetVersion: TAisa35GetVersion;
	pAisa35Create: TAisa35Create;
	pAisa35Close: TAisa35Close;
	pAisa35GetResource: TAisa35GetResource;
	pAisa35StartSampling: TAisa35StartSampling;
	pAisa35InPort: TAisa35InPort;
	pAisa35OutPort: TAisa35OutPort;
	pAisa35GetLastError: TAisa35GetLastError;


//****************************************************************************
// 		aisa35.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa35wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA35_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa35wGetDllExportFunc = False then
	begin
		Aisa35wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		aisa35.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa35wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// 		aISA-A35 DLL,Vxd̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drvo[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa35wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa35GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aISA-A35̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa35wCreate(var pwLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa35Create(pwLogSlot);
end;

//****************************************************************************
// 		aISA-A35̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Aisa35wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa35Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pres		 \[Xi[\
// ߂l  True
//				s False
//****************************************************************************
function Aisa35wGetResource(wLogSlot: Word; pres: PAISA35RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa35GetResource(wLogSlot, pres);
end;

//****************************************************************************
// 		A/DTvO̎s
// 		wLogSlot			 TvOfoCX
//				pcpara				 TvOp[^
//				pwSamplingData TvOf[^
// ߂l  True
//				s False
//****************************************************************************
function Aisa35wStartSampling(wLogSlot: Word; pcpara: PAISA35PARA; var pwSamplingData: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa35StartSampling(wLogSlot, pcpara, pwSamplingData);
end;

//****************************************************************************
// 		Cӂ̃|[gf[^
// 		wLogSlot	͂foCX
//				pbInValue ̓f[^i[
// ߂l  True
//				s False
//****************************************************************************
function Aisa35wInPort(wLogSlot: Word; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa35InPort(wLogSlot, pbInValue);
end;

//****************************************************************************
// 		Cӂ̃|[gփf[^o
// 		wLogSlot	o͂foCX
//				bOutValue o͂f[^
// ߂l  True
//				s False
//****************************************************************************
function Aisa35wOutPort(wLogSlot: Word; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa35OutPort(wLogSlot, bOutValue);
end;

//****************************************************************************
// 		aISA-A35̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Aisa35wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA35_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa35GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Aisa35wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa35GetVersion ̃AhX擾
	pAisa35GetVersion := GetProcAddress(hDLL, 'Aisa35GetVersion');
	if @pAisa35GetVersion = nil then Exit;

	// Aisa35Create ̃AhX擾
	pAisa35Create := GetProcAddress(hDLL, 'Aisa35Create');
	if @pAisa35Create = nil then Exit;

	// Aisa35Close ̃AhX擾
	pAisa35Close := GetProcAddress(hDLL, 'Aisa35Close');
	if @pAisa35Close = nil then Exit;

	// Aisa35GetResource ̃AhX擾
	pAisa35GetResource := GetProcAddress(hDLL, 'Aisa35GetResource');
	if @pAisa35GetResource = nil then Exit;

	// Aisa35StartSampling ̃AhX擾
	pAisa35StartSampling := GetProcAddress(hDLL, 'Aisa35StartSampling');
	if @pAisa35StartSampling = nil then Exit;

	// Aisa35InPort ̃AhX擾
	pAisa35InPort := GetProcAddress(hDLL, 'Aisa35InPort');
	if @pAisa35InPort = nil then Exit;

	// Aisa35OutPort ̃AhX擾
	pAisa35OutPort := GetProcAddress(hDLL, 'Aisa35OutPort');
	if @pAisa35OutPort = nil then Exit;

	// Aisa35GetLastError ̃AhX擾
	pAisa35GetLastError := GetProcAddress(hDLL, 'Aisa35GetLastError');
	if @pAisa35GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

