Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       aisa35.bas
'
'       aISA-A35 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' Error Code

Global Const AISA35_SUCCESS = 0                  ' Successfully proccessed
Global Const AISA35_ERR_SYSTEM = 1               ' Call GetLastError()
Global Const AISA35_ERR_NO_DEVICE = 2            ' No card
Global Const AISA35_ERR_IN_USE = 3               ' Device is in use
Global Const AISA35_ERR_INVALID_SLOT = 4         ' Invalid slot number
Global Const AISA35_ERR_RESOURCE = 5             ' Resource exhaustion
Global Const AISA35_ERR_INVALID_ARGUMENT = 6     ' Invalid argument
Global Const AISA35_ERR_NO_CREATE = 7            ' No created device
Global Const AISA35_ERR_INVALID_CHANNEL = 8      ' Invalid channel
Global Const AISA35_ERR_INVALID_RESOLUTION = 9   ' Invalid resolution
Global Const AISA35_ERR_TIMEOUT = 10             ' Conversion timeout

' Miscellaneous

Global Const AISA35_MAX_SLOTS = 16             ' Maximum number of slots

Global Const AISA35_SLOT_AUTO = &HFFFF         ' default search

' Device ID

' Resource infomation structure

Global Const AISA35_MAX_MEM = 9
Global Const AISA35_MAX_IO = 20
Global Const AISA35_MAX_IRQ = 7
Global Const AISA35_MAX_DMA = 7

Type AISA35RESOURCE
    dwNumMemWindows As Long                     ' س޳       gp
    dwMemBase(1 To AISA35_MAX_MEM) As Long      ' س޳ްڽgp
    dwMemLength(1 To AISA35_MAX_MEM) As Long    ' س޳       gp
    dwMemAttrib(1 To AISA35_MAX_MEM) As Long    ' س޳     gp
    dwNumIOPorts As Long                        ' I/O߰Đ
    dwIOPortBase(1 To AISA35_MAX_IO) As Long    ' I/O߰ްڽ
    dwIOPortLength(1 To AISA35_MAX_IO) As Long  ' I/O߰Ē
    dwNumIRQs As Long                           ' IRQ             gp
    dwIRQRegisters(1 To AISA35_MAX_IRQ) As Long ' IRQؽ            gp
    dwIRQAttrib(1 To AISA35_MAX_IRQ) As Long    ' IRQؽ        gp
    dwNumDMAs As Long                           ' DMAِ         gp
    dwDMALst(1 To AISA35_MAX_DMA) As Long       ' DMAؽ        gp
    dwDMAAttrib(1 To AISA35_MAX_DMA) As Long    ' DMAّؽ    gp
    dwReserved1(1 To 3) As Long                 ' \              gp
End Type

' Sampling parameter structure

Type AISA35PARA
    dwSamplingChannel As Long   'TvOs`li1`8j
    dwResolution As Long        '\i 8 = 8 [bit] / 12 = 12 [bit] j
End Type

Declare Function Aisa35GetVersion Lib "aisa35" (pdwDllVersion As Long, pdwDriverVersion As Long) As Long
Declare Function Aisa35Create Lib "aisa35" (pwLogSlot As Integer) As Long
Declare Function Aisa35Close Lib "aisa35" (ByVal wLogSlot As Integer) As Long
Declare Function Aisa35GetResource Lib "aisa35" (ByVal wLogSlot As Integer, pres As AISA35RESOURCE) As Long
Declare Function Aisa35StartSampling Lib "aisa35" (ByVal wLogSlot As Integer, pcpara As AISA35PARA, pwSamplingData As Integer) As Long
Declare Function Aisa35InPort Lib "aisa35" (ByVal wLogSlot As Integer, pbInValue As Byte) As Long
Declare Function Aisa35OutPort Lib "aisa35" (ByVal wLogSlot As Integer, ByVal bOutValue As Byte) As Long
Declare Function Aisa35GetLastError Lib "aisa35" (ByVal wLogSlot As Integer) As Long
